#define BAD_BOUND 1
#define D 0
#define N 6
#include <iomanip>
#include <map>
#include <bitset>
#include <iostream>
#define TY __typeof
#define SZ size()
#define PB push_back
#define MP make_pair
#define FOR(i,x,n) for(TY(x) i=(x); i!=(n); i++)
#define FRD(i,  n) for(TY(n) i=(n); i--!=0; )
#define FR(i,n)   FOR(i,0,n)
#define FRI(it,v)  FOR(it,v.begin(),v.end())
#define CLR(a,v)   memset((a),(v),sizeof(a))
#define ALL(x)     x.begin(),(x).end()
#define show(x) cerr<<#x<<"="<<x<<endl
#define isin(x,s) (s.find(x)!=s.end())

using namespace std;
typedef bitset<5> B;
typedef long long LL;

char numNeed[16], num[16], mask[16], allNeed[16];
char revmap[4][8];

const string INV = "_";
const int n = N;
int rownum;

typedef map<string, int> M;
M poss[10], domain, tp;

#define apply(x, y) ((num[y] >= num[x]) ? x : revmap[num[x]][mask[x] | (1<< num[y])])
#define subset(x, y) ( ((x) | (y)) == (y) )

string putOver(const string &p, string newr) {
  FR(i,n) 
    if (numNeed[apply(p[i], newr[i])] != 0)
      return INV;
  FR(i,n) {
    newr[i] = apply(newr[i], p[i]);
    if (numNeed[newr[i]] > 1)
      return INV;
  }
  return newr;
}

bool moreFree(const string &p1, const string &p2) {
  FR(i,n) 
    if (!(subset(allNeed[p1[i]],allNeed[p2[i]])))
      return false;
  return true;
}

void relax(M &m) {
  if (D) cerr << "BEFORE RELAX: " << m.SZ;
  tp.clear();
  FRI(it,m) {
    FRI(jt, tp) {//poss[rownum]) {
      if (jt->second >= it->second && moreFree(jt->first, it->first))
	goto nextit;
    }
    tp.insert(*it);
  nextit: ;
  }
  m = tp; 
  if (D) cerr << " ******* AFTER RELAX: " << m.SZ << endl;
}

int main() {
  int cur = 0;
  FR(i,4) FR(j, (1<<i)) { 
    int x = cur++;
    num[x] = i; mask[x] = j; 
    FR(k,i) if ((j & (1 << k)) == 0) { numNeed[x] ++; allNeed[x] |= (1 << k); }
    //cerr << x << " " << (int)num[x] << " " << (int)mask[x] << " " << (int)numNeed[x] << endl;
    revmap[(int)num[x]][(int)mask[x]] = x;
  }

  domain.clear(); poss[0].clear(); poss[1].clear();
  FR(b, (1<<(2*n))) {
    string s(n, ' ');
    int no3 = 0;
    FR(i,n) { s[i] = revmap[(b >> (2*i)) & 3][0]; }
    FR(i,n) {
      if (i > 0  ) s[i] = apply(s[i], s[i-1]);
      if (i < n-1) s[i] = apply(s[i], s[i+1]);
      no3 += (num[s[i]] == 3);
    }
    domain[s] = no3;
  }

  poss[0] = domain; // initial
  if (BAD_BOUND) relax(poss[0]);
  for (rownum = 1; rownum < 7; rownum++) {
    long long all = 0, success = 0, cnt[20];
    CLR(cnt, 0);
    if (D) show(poss[rownum-1].SZ);
    FRI(dt, domain) {
      FRI(it, poss[rownum-1]) {
	string ret = putOver(it->first, dt->first);
	if (D) all++; 
	if (ret == INV) continue;
	int c = it->second + dt->second;
	if (D) success++;
	if (D) cnt[c]++;
	poss[rownum][ret] >?= c;
      }
    }
    int best = 0;
    FRI(it, poss[rownum]) {
      FR(i,n)
	if (numNeed[(it->first)[i]] != 0) goto next;
      best >?= it->second;
    next: ;
    }

    if (BAD_BOUND) relax(poss[rownum]);
    cerr << n << "x" << rownum+1 << " : " << best;
    if (D) cerr << " | " << success << " / " << all; cerr << endl;
    if (D) FR(i,16) cerr << setw(6) << cnt[i] << " "; cerr << endl;
  }


  return 0;
}
