//Problem F of ACM ICPC, Tehran Region, December 2008
//Author: Nima Ahmadi Pour Anari
//From team: AnacondaTigers of SUT
#include <iostream>
#include <complex>
#include <cmath>
#include <vector>
#include <iomanip>
#define X real()
#define Y imag()
using namespace std;
const double eps=1e-7;
typedef complex<double> point;
inline bool zero(double t){return t<eps && t>-eps;}
bool equal(const point& a,const point& b){
	return zero(a.Y-b.Y) && zero(a.X-b.X);
}
double dot(const point& a,const point& b){
	return a.X*b.X+a.Y*b.Y;
}
double cross(const point& a,const point& b){
	return a.X*b.Y-a.Y*b.X;
}
struct line{
	point v;
	double c;
	void normalize(){double t=abs(v);if (zero(t)) throw -1;v/=t;c/=t;}
	line(){}
	line(const point& _v,const double& _c):v(_v),c(_c){normalize();}
	line(const point& p,const point& q){v=point(0,1)*(p-q);c=dot(v,p);normalize();}
};
struct circle{
	point o;double r;
	circle(){}
	circle(const point& _o,double _r):o(_o),r(_r){}
};
point intersection(const line& l,const circle& c){
	double t=l.c-dot(l.v,c.o);t*=t;t=c.r*c.r-t;
	if (t<-eps) throw -1;
	else if (t<eps) t=0;
	t=sqrt(t);t+=cross(c.o,l.v);
	return l.c*l.v-t*l.v*point(0,1);
}
point intersection(const circle& c1,const circle& c2){
	return intersection(line(2.0*(c2.o-c1.o),norm(c2.o)-norm(c1.o)+c1.r*c1.r-c2.r*c2.r),c2);
}
int n;
double R;
circle c[100];
vector<point> p;
int main(){
	cout<<fixed<<setprecision(6);
	while (cin>>n>>R,n||!zero(R)){
		R*=2;
		for (int i=0;i<n;++i){
			double x,y;cin>>x>>y;
			c[i]=circle(point(x,y),R);
		}
		p.clear();
		p.push_back(point(0,0));
		for (int i=0;i<n;++i)
			for (int j=0;j<n;++j){
				try{
					p.push_back(intersection(c[i],c[j]));
				}
				catch(int){}
			}
		for (int i=0;i<n;++i){
			p.push_back(c[i].o+point(c[i].r,0));
			if (!zero(abs(c[i].o))){
				point u=c[i].o/abs(c[i].o);
				p.push_back(c[i].o-c[i].r*u);
				p.push_back(c[i].o+c[i].r*u);
			}
		}
		double ans=1e22;
		for (int i=0;i<p.size();++i){
			point q=p[i];
			for (int j=0;j<n;++j)
				if (abs(q-c[j].o)<c[j].r-eps){
					goto next;
				}
			ans=min(ans,abs(q));
next:;
		}
		cout<<ans<<endl;
	}
	return 0;
}
