//Problem H of ACM ICPC, Tehran Region, December 2008
//Author: Aideen NasiriShargh
//From team: AnacondaTigers of SUT
#define D 0
#include <sstream>
#include <map>
#include <cstdio>
#include <iostream>
#include <set>
#define FOR(i,x,n) for(__typeof(x) i = (x); i != (n); i++)
#define FR(i,n) FOR(i,0,n)
#define FRI(it,v) FOR(it,v.begin(),v.end())
#define CLR(a,v) memset(a, v, sizeof a);
#define PB push_back
#define SZ size()
#define show(x) cerr << #x << " = " << x << endl;
using namespace std;

const int Maxa = 1, Maxb = 2, Maxc=6;

struct Triple{
  int a,b,c;
  bool valid() { return (a<=Maxa && b <=Maxb && c<=Maxc); }
  int profit() const { return (25*(a) + 8*(b) + 1*(c)); }
  int revprofit() const { return (25*(Maxa-a) + 8*(Maxb-b) + 1*(Maxc-c)); }
  Triple rev() const { return Triple(Maxa-a, Maxb-b, Maxc-c); }
  friend ostream &operator << (ostream &out, const Triple &s) { out << (s.a) << " " << (s.b) << " " << (s.c); return out; }
  Triple(int _a=0, int _b=0, int _c=0): a(_a), b(_b), c(_c) {}
};

bool operator < (const Triple &f1, const Triple &f2)  {
  //if (f1.m != f2.m) return (f1.m < f2.m);
  if (f1.a != f2.a) return (f1.a < f2.a);
  if (f1.b != f2.b) return (f1.b < f2.b);
  if (f1.c != f2.c) return (f1.c < f2.c);
  return false;
}

int n, m;

map<Triple, int> mymap, news;
string s;
char ch[100];

void showall() {
  cerr << "Showing All: ";
  FRI(it,mymap)
    cerr << " | " << it->first <<":"<< it->second;
  cerr << endl;
}

int main() {
  int oa, ob, oc;

  while (cin >> n >> m && n) {
    mymap.clear();
    Triple def(0,0,0);
    mymap[def] = 0;


    // read parties
    FR(i,n) {
      do { getline(cin, s); } while (s.SZ == 0);
      stringstream ss(s);
      int seats;
      ss >> seats;
      if (D) show(seats);

      news.clear();
      // each offer of party
      do {
	ss >> ch[0] >> ch[5] >> oa >> ch[1] >> ob >> ch[2] >> oc >> ch[3] >> ch[4];
	//if (D) cerr << "!" << oa << " " << ob << " " << oc << endl;
	
	FRI(it,mymap) {
	  Triple cur = it->first;
	  int val = it->second;
	  cur.a += oa; cur.b += ob; cur.c += oc; val += seats;
	  if (cur.valid() && (news.find(cur) == news.end() || news[cur] < val ))
	    news[cur] = val;
	}

      } while (ch[4] != ';');

      FRI(it, news) {
	if (mymap.find(it->first) == mymap.end() || mymap[it->first] < it->second)
	  mymap[it->first] = it->second;
      }
      if (D) showall();
      
    }

    // write answer
    Triple ans(1,2,6);
    FRI(it,mymap) 
      if (it->second >= m && (it->first).revprofit() > ans.revprofit())
	ans = it->first;
    cout << ans.rev() << endl;
  }

  return 0;
}
